package net.gencat.ctti.canigo.exempleCrudAmbFiltre.action;

import java.util.HashMap;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.gencat.ctti.canigo.exempleCrudAmbFiltre.bo.PoblacioBO;
import net.gencat.ctti.canigo.exempleCrudAmbFiltre.excepcions.NoPotCanviarPoblacioException;
import net.gencat.ctti.canigo.exempleCrudAmbFiltre.excepcions.PoblacioJaExisteixALaComarcaException;
import net.gencat.ctti.canigo.exempleCrudAmbFiltre.model.Poblacio;
import net.gencat.ctti.canigo.services.exceptions.ExceptionDetails;
import net.gencat.ctti.canigo.services.exceptions.Layer;
import net.gencat.ctti.canigo.services.exceptions.WrappedCheckedException;
import net.gencat.ctti.canigo.services.logging.LoggingService;
import net.gencat.ctti.canigo.services.web.lists.ValueListActionHelper;
import net.gencat.ctti.canigo.services.web.struts.DispatchActionSupport;
import net.gencat.ctti.canigo.services.web.struts.SpringBindingActionForm;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * ======================================================================
 * OT Canig
 * 
 * Aquesta classe cont les accions associades al formulari 
 * (l'associaci de formulari-acci es fa en el fitxer action-servlet.xml)
 * =======================================================================
 *
 */

public class PoblacioAction extends DispatchActionSupport {
	class FormExtractor<E>{
		@SuppressWarnings("unchecked")
		public E extractPojo(ActionForm form){
			SpringBindingActionForm springBindingActionForm = (SpringBindingActionForm) form;
			return (E) springBindingActionForm.getTarget();
		}
		
		@SuppressWarnings("unchecked")
		public E clearPojo(ActionForm form) throws InstantiationException, IllegalAccessException{
			SpringBindingActionForm springBindingActionForm = (SpringBindingActionForm) form;
			E target = (E) springBindingActionForm.getTarget();
			springBindingActionForm.expose(target.getClass().newInstance());
			return target;
		}
	}

	private FormExtractor<PoblacioActionPojo> formExtractor = new FormExtractor<PoblacioActionPojo>();
	private ValueListActionHelper valueListActionHelper;
	private PoblacioBO poblacioBO;

	/**
	 * Mtode que es crida pel reqCode=create
	 * @param mapping ActionMapping
	 * @param form ActionForm
	 * @param request HttpServletRequest
	 * @param response HttpServletResponse
	 * @return ActionForward 
	 * @throws Exception exception
	 */
	public ActionForward create(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
//		valueListActionHelper.search(mapping, form, request, response);
		PoblacioActionPojo poblacioPojo = new PoblacioActionPojo();
		((SpringBindingActionForm) form).expose(poblacioPojo);

		poblacioPojo.setAllComarques(poblacioBO.getAllComarques());

		poblacioPojo.setFiltreVisible(false);
		poblacioPojo.setEditaVisible(true);
		poblacioPojo.setPoblacioIsNewInstance(true);
		valueListActionHelper.search(mapping, form, request, response);

		setDefaultSuccessMessage("crear.nova.Poblacio");
		return mapping.findForward("edit");
	}
	
	/**
	 * Mtode que es crida pel reqCode=edit
	 * 
	 * @param mapping
	 *            ActionMapping
	 * @param form
	 *            ActionForm
	 * @param request
	 *            HttpServletRequest
	 * @param response
	 *            HttpServletResponse
	 * @return ActionForward
	 * @throws Exception
	 *             exception
	 */
	public ActionForward edit(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		PoblacioActionPojo poblacioPojo = formExtractor.extractPojo(form);
		poblacioBO.refresh(poblacioPojo.getPoblacio());
		valueListActionHelper.search(mapping, form, request, response);
		poblacioPojo.setAllComarques(poblacioBO.getAllComarques());
		setDefaultSuccessMessage("editar.Poblacio");
		poblacioPojo.setFiltreVisible(false);
		poblacioPojo.setEditaVisible(true);
		poblacioPojo.setPoblacioIsNewInstance(false);
		return mapping.findForward("edit");
	}
	
	/**
	 * Mtode que es crida pel reqCode=search
	 * 
	 * @param mapping
	 *            ActionMapping
	 * @param form
	 *            ActionForm
	 * @param request
	 *            HttpServletRequest
	 * @param response
	 *            HttpServletResponse
	 * @return ActionForward
	 * @throws Exception
	 *             exception
	 */
	public ActionForward search(ActionMapping mapping,
		      ActionForm form, HttpServletRequest request,
		      HttpServletResponse response)
		      throws Exception {
		PoblacioActionPojo poblacioPojo = formExtractor.extractPojo(form);
		poblacioPojo.setFiltreVisible(true);		
		valueListActionHelper.search(mapping, form, request, response);
		poblacioPojo.setAllComarques(poblacioBO.getAllComarques());
		setDefaultSuccessMessage("editar.Poblacio");
	    return mapping.findForward("edit");
	}
	
	/**
	 * Mtode que es crida pel reqCode=searchSenseFiltre
	 * @param mapping ActionMapping
	 * @param form ActionForm
	 * @param request HttpServletRequest
	 * @param response HttpServletResponse
	 * @return ActionForward 
	 * @throws Exception exception
	 */
	public ActionForward searchSenseFiltre(ActionMapping mapping,
		      ActionForm form, HttpServletRequest request,
		      HttpServletResponse response)
		      throws Exception {
		    netejaPojo(form, request);
			valueListActionHelper.search(mapping, form, request, response);
			setDefaultSuccessMessage("editar.Poblacio");
		    return mapping.findForward("edit");
	}
	
	public ActionForward cancel(ActionMapping mapping,
			ActionForm form, HttpServletRequest request,
			HttpServletResponse response)
			throws Exception {

		valueListActionHelper.search(mapping, form, request, response);
		setDefaultSuccessMessage("editar.Poblacio");
		return mapping.findForward("edit");
	}

	/**
	 * Esborra tots els PoblacioActionPojo de la request
	 * @param form ActionForm
	 * @param request HttpServletRequest
	 */
	private void netejaPojo(ActionForm form, HttpServletRequest request) throws Exception {
		PoblacioActionPojo poblacioPojo = new PoblacioActionPojo();
		((SpringBindingActionForm) form).expose(poblacioPojo);		
		poblacioPojo.setFiltre(new Poblacio());
		poblacioPojo.setAllComarques(poblacioBO.getAllComarques());
	}
	
	/**
	 * Mtode que es crida pel reqCode=save
	 * @param mapping ActionMapping
	 * @param form ActionForm
	 * @param request HttpServletRequest
	 * @param response HttpServletResponse
	 * @return ActionForward 
	 * @throws Exception exception
	 */
	public ActionForward save(ActionMapping mapping,
		      ActionForm form, HttpServletRequest request,
		      HttpServletResponse response)
		      throws Exception {
			PoblacioActionPojo poblacioPojo = formExtractor.extractPojo(form);
			//comprovaParent(poblacioPojo);
			poblacioBO.refresh(poblacioPojo.getPoblacio().getComarca());
			try{
				if (poblacioPojo.isPoblacioIsNewInstance()) {
					poblacioBO.addPoblacio(poblacioPojo.getPoblacio().getComarca(), poblacioPojo.getPoblacio());
					
					Map<Object, Object> filter = new HashMap<Object, Object>();
					filter.put("pagingPage", "1");
					request.setAttribute(ValueListActionHelper.VALUE_LIST_FILTERS_ATTRIBUTE_NAME, filter);
				}else {
					poblacioBO.updatePoblacio(poblacioPojo.getPoblacio());
				}
			}
			catch(PoblacioJaExisteixALaComarcaException e){
				ExceptionDetails exceptionDetails = new ExceptionDetails("poblacio.nom.ja.existeix", new Object[]{poblacioPojo},Layer.BUSINESS);				
				throw new WrappedCheckedException(e, exceptionDetails);
			} catch(NoPotCanviarPoblacioException e){
				ExceptionDetails exceptionDetails = new ExceptionDetails("no.modificar.poblacio", new Object[]{poblacioPojo},Layer.BUSINESS);				
				throw new WrappedCheckedException(e, exceptionDetails);
			}  finally {
				valueListActionHelper.search(mapping, form, request, response);
				poblacioPojo.setAllComarques(poblacioBO.getAllComarques());
			}
			poblacioPojo.setPoblacio(new Poblacio());
			((SpringBindingActionForm) form).expose(poblacioPojo);				
			poblacioPojo.setFiltreVisible(true);
			setDefaultSuccessMessage("desar.Poblacio");
		    return mapping.findForward("edit");
	}
	
	/**
	 * Mtode que es crida pel reqCode=delete
	 * @param mapping ActionMapping
	 * @param form ActionForm
	 * @param request HttpServletRequest
	 * @param response HttpServletResponse
	 * @return ActionForward 
	 * @throws Exception exception
	 */
	public ActionForward delete(ActionMapping mapping,
		      ActionForm form, HttpServletRequest request,
		      HttpServletResponse response)
		      throws Exception {
			PoblacioActionPojo poblacioPojo = formExtractor.extractPojo(form);
			//comprovaParent(poblacioPojo);
			poblacioBO.refresh(poblacioPojo.getPoblacio().getComarca());
		    try {
				poblacioBO.delete(poblacioPojo.getPoblacio());				
			}catch (Exception e) {
				ExceptionDetails exceptionDetails = new ExceptionDetails("error.delete", new Object[]{poblacioPojo},Layer.BUSINESS);
				throw new WrappedCheckedException(e, exceptionDetails);
			} finally {
				valueListActionHelper.search(mapping, form, request, response);
				poblacioPojo.setAllComarques(poblacioBO.getAllComarques());
			}
			poblacioPojo = new PoblacioActionPojo();
			((SpringBindingActionForm) form).expose(poblacioPojo);
			setDefaultSuccessMessage("esborrar.Poblacio");
			return mapping.findForward("edit");
	}
	
	/**
	 * @return the logService
	 */
	public void setLogService(LoggingService logService) {
		super.setLogService(logService);
	}

	/**
	 * @return the poblacioBO
	 */
	public PoblacioBO getPoblacioBO() {
		return poblacioBO;
	}

	/**
	 * @param poblacioBO the poblacioBO to set
	 */
	public void setPoblacioBO(PoblacioBO poblacioBO) {
		this.poblacioBO = poblacioBO;
	}

	/**
	 * @return the valueListActionHelper
	 */
	public ValueListActionHelper getValueListActionHelper() {
		return valueListActionHelper;
	}

	/**
	 * @param valueListActionHelper the valueListActionHelper to set
	 */
	public void setValueListActionHelper(ValueListActionHelper valueListActionHelper) {
		this.valueListActionHelper = valueListActionHelper;
	}
}
