package net.gencat.ctti.canigo.exempleCrudAmbFiltre.excepcions;

import org.hibernate.validator.InvalidStateException;

import net.gencat.ctti.canigo.services.exceptions.ExceptionDetails;
import net.gencat.ctti.canigo.services.exceptions.Layer;
import net.gencat.ctti.canigo.services.exceptions.WrappedCheckedException;
import net.gencat.ctti.canigo.services.exceptions.handlers.ExceptionHandlerAdapter;

public class HibernateValidatorExceptionHandler extends ExceptionHandlerAdapter {

	@Override
	public void handleException(Throwable e) throws Throwable {
		if(e instanceof InvalidStateException){
			InvalidStateException invalidStateException = (InvalidStateException) e;
			ExceptionDetails exceptionDetails = new ExceptionDetails();
			exceptionDetails.setLayer(Layer.DATAACCESS);
			exceptionDetails.setBaseException(e);
			exceptionDetails.setErrorCode("error.hibernate.validator");
			exceptionDetails.setArguments(invalidStateException.getInvalidValues());
			exceptionDetails.setErrorMessage(invalidStateException.getLocalizedMessage());
			exceptionDetails.setOtherExceptionDetails(invalidStateException.getInvalidValues());
			throw new WrappedCheckedException(e, exceptionDetails);
		}

	}

}
