package net.gencat.ctti.canigo.exempleCrudAmbFiltre.model;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;

/**
 * =======================================================================
 * OT Canig
 * 
 * Aquesta classe s una entitat persistent.
 * T com a atributs un identificador (PK) i nom, i est associat a 
 * l'entitat Poblacio amb relaci 1:N
 * ========================================================================
 *
 */

@Entity
public class Comarca implements Serializable {
	private static final long serialVersionUID = -3865170365563197618L;

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	private Long id;
	
	private String nomComarca;
	
	@OneToMany(mappedBy = "comarca", cascade = CascadeType.ALL)
	private List<Poblacio> poblacions = null;

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getNomComarca() {
		return nomComarca;
	}

	public void setNomComarca(String nomComarca) {
		this.nomComarca = nomComarca;
	}
	
	public void addPoblacio(Poblacio poblacio) {
		poblacio.setComarca(this);
		if (poblacions == null) {
			poblacions = new ArrayList<Poblacio>();
		}
		poblacions.add(poblacio);
	}

	public void removePoblacio(Poblacio linia) {
		linia.setComarca(null);
		poblacions.remove(linia);
	}

	public List<Poblacio> getPoblacions() {
		return poblacions;
	}
	
	public void setPoblacions(List<Poblacio> linies) {
		this.poblacions = linies;
	}
	
	@Override
	public boolean equals(Object arg0) {
		if (arg0 == null) {
			return false;
		}
		if (arg0 instanceof Comarca) {
			Comarca otherComarca = (Comarca) arg0;
			return otherComarca.getId().equals(this.getId());
		}
		return super.equals(arg0);
	}

	@Override
	public int hashCode() {
		return this.id.hashCode();
	}

	public String toString() {
		return nomComarca;
	}
}
