package net.gencat.ctti.canigo.exempleCrudAmbFiltre.model;

import java.io.Serializable;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;

/**
 * =======================================================================
 * OT Canig
 * 
 * Aquesta classe s una entitat persistent.
 * T com a atributs un identificador (PK) i nom, i est associat a 
 * l'entitat Comarca amb relaci N:1
 * ========================================================================
 *
 */

@Entity
@NamedQueries( {
   @NamedQuery( name = "Poblacio.findPoblacionsByComarca", 
		     query = "SELECT poblacio FROM Poblacio poblacio WHERE poblacio.comarca.id=?1" ),
   @NamedQuery( name = "Poblacio.findInPoblacioIds", 
		     query = "SELECT o FROM Poblacio o  WHERE  o.id in  ( ?1 )" ),
	@NamedQuery( name = "Poblacio.findComarcaByPoblacio",
			query = "SELECT comarca FROM Poblacio poblacio WHERE poblacio.id=?1")
		     
} )
public class Poblacio implements Serializable {
	private static final long serialVersionUID = 7600830437933193864L;

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	private Long id;
	
	private String nomPoblacio;
	
	@ManyToOne
	private Comarca comarca;
	private int poblacio;
	
	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}
	
	public String getNomPoblacio() {
		return nomPoblacio;
	}

	public void setNomPoblacio(String nomPoblacio) {
		this.nomPoblacio = nomPoblacio;
	}

	public Comarca getComarca() {
		return comarca;
	}
	
	public void setComarca(Comarca comarca) {
		this.comarca = comarca;
	}
	
	public int getPoblacio() {
		return poblacio;
	}
	
	public void setPoblacio(int poblacio) {
		this.poblacio = poblacio;
	}

	@Override
	public boolean equals(Object arg0) {
		if (arg0 == null) {
			return false;
		}
		if (arg0 instanceof Poblacio) {
			Poblacio otherPoblacio = (Poblacio) arg0;
			return otherPoblacio.getId().equals(this.getId());
		}
		return super.equals(arg0);
	}

	@Override
	public int hashCode() {
		return this.id.hashCode();
	}

	public String toString() {
		return nomPoblacio;
	}
}
