package net.gencat.ctti.canigo.exempleMestreDetall.action;


import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.gencat.ctti.canigo.exempleMestreDetall.bo.FacturaBO;
import net.gencat.ctti.canigo.exempleMestreDetall.model.Factura;
import net.gencat.ctti.canigo.exempleMestreDetall.model.Linia;
import net.gencat.ctti.canigo.services.exceptions.WrappedCheckedException;
import net.gencat.ctti.canigo.services.logging.LoggingService;
import net.gencat.ctti.canigo.services.web.lists.ValueListActionHelper;
import net.gencat.ctti.canigo.services.web.struts.DispatchActionSupport;
import net.gencat.ctti.canigo.services.web.struts.taglib.layout.util.FormUtils;
import net.mlw.vlh.DefaultListBackedValueList;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;


/**
 * ======================================================================
 * OT Canig
 * 
 * Aquesta classe cont les accions associades al formulari 
 * (l'associaci de formulari-acci es fa en el fitxer action-servlet.xml)
 * =======================================================================
 *
 */

public class FacturaAction extends DispatchActionSupport{
	// Veieu la classe FormExtractor al mateix paquet que cont metodes 
	//per extreure el pojo del formulari i per seetejar el mateix formulari
	private FormExtractor<FacturaMestreDetallPojo> formExtractor = new FormExtractor<FacturaMestreDetallPojo>();
	
	private ValueListActionHelper valueListActionHelper;
	private ValueListActionHelper liniesValueListActionHelper;
	private FacturaBO facturaBO;

	public ValueListActionHelper getLiniesValueListActionHelper() {
		return liniesValueListActionHelper;
	}

	public void setLiniesValueListActionHelper(ValueListActionHelper liniesValueListActionHelper) {
		this.liniesValueListActionHelper = liniesValueListActionHelper;
	}
	
	public FacturaBO getFacturaBO() {
		return facturaBO;
	}

	public void setFacturaBO(FacturaBO facturaBO) {
		this.facturaBO = facturaBO;
	}

	public ValueListActionHelper getValueListActionHelper() {
		return valueListActionHelper;
	}

	public void setValueListActionHelper(ValueListActionHelper valueListActionHelper) {
		this.valueListActionHelper = valueListActionHelper;
	}

	public void setLogService(LoggingService logService) {
		super.setLogService(logService);
	}
	
	public ActionForward search(ActionMapping mapping,
		      ActionForm form, HttpServletRequest request,
		      HttpServletResponse response)
		      throws Exception {
			valueListActionHelper.search(mapping, form, request, response);
		    return mapping.findForward("list");
	}
	
	public ActionForward create(ActionMapping mapping,
			      ActionForm form, HttpServletRequest request,
			      HttpServletResponse response)
			      throws Exception {
		
		FacturaMestreDetallPojo facturaContainerPojo = formExtractor.clearPojo(form);
		clearLiniaValueList(mapping, form, request, response);
		facturaContainerPojo.setCurrentLiniaVisible(false);
		setDefaultSuccessMessage("creada.nova.factura");
	    return mapping.findForward("view");
	}

	private void clearLiniaValueList(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {
		request.setAttribute(valueListActionHelper.getListAttributeName(),new DefaultListBackedValueList(new ArrayList<Object>()));
	}
	
	public ActionForward save(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		FacturaMestreDetallPojo facturaContainerPojo = formExtractor.extractPojo(form);
		facturaBO.save(facturaContainerPojo.getFactura());
		attachFactura(facturaContainerPojo);
		setDefaultSuccessMessage("desada.factura");
		// Mode del formulari a INSPECT (consulta)
		FormUtils.setFormDisplayMode(request, form,FormUtils.INSPECT_MODE);
	    return mapping.findForward("view");
	}

	private void preparaLiniaValuelist(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response,
			FacturaMestreDetallPojo facturaContainerPojo) throws InstantiationException, IllegalAccessException {

		liniesValueListActionHelper.search(mapping, form, request, response);
		facturaContainerPojo.setLiniaListVisible(true);
	}
	
	public ActionForward view(ActionMapping mapping,
		      ActionForm form, HttpServletRequest request,
		      HttpServletResponse response)
		      throws Exception {
		FacturaMestreDetallPojo facturaContainerPojo = formExtractor.extractPojo(form);
		attachFactura(facturaContainerPojo);
		facturaContainerPojo.setLiniaListVisible(true);
		liniesValueListActionHelper.search(mapping, form, request, response);
		setDefaultSuccessMessage("edita.factura");
		calculaTotalFactura(request, facturaContainerPojo);
		
	    return mapping.findForward("view");
	}
	
	public ActionForward delete(ActionMapping mapping,
		      ActionForm form, HttpServletRequest request,
		      HttpServletResponse response)
		      throws Exception {
		FacturaMestreDetallPojo facturaContainerPojo = formExtractor.extractPojo(form);
		attachFactura(facturaContainerPojo);
		Factura factura = facturaContainerPojo.getFactura();
		facturaBO.delete(factura);
		valueListActionHelper.search(mapping, form, request, response);
		setDefaultSuccessMessage("esborrada.factura");
	    return mapping.findForward("list");
	}

	public ActionForward createLinia(ActionMapping mapping,
		      ActionForm form, HttpServletRequest request,
		      HttpServletResponse response)
		      throws Exception {
			FacturaMestreDetallPojo facturaContainerPojo = formExtractor.extractPojo(form);
			attachFactura(facturaContainerPojo);
			facturaContainerPojo.setCurrentLinia(new Linia());
			formExtractor.expose(form, facturaContainerPojo);
			facturaContainerPojo.setCurrentLiniaVisible(true);
			facturaContainerPojo.setCurrentLiniaIsNewInstance(true);
			liniesValueListActionHelper.search(mapping, form, request, response);
			setDefaultSuccessMessage("creada.nova.linia");
			calculaTotalFactura(request, facturaContainerPojo);
		    
		    return mapping.findForward("view");
	}
	
	public ActionForward editFactura(ActionMapping mapping,
		      ActionForm form, HttpServletRequest request,
		      HttpServletResponse response)
		      throws Exception {
			FacturaMestreDetallPojo facturaContainerPojo = formExtractor.extractPojo(form);
			attachFactura(facturaContainerPojo);
			facturaContainerPojo.setLiniaVisible(false);
			setDefaultSuccessMessage("edita.factura");
			calculaTotalFactura(request, facturaContainerPojo);
		    return mapping.findForward("view");
	}
	
	public ActionForward editLinia(ActionMapping mapping,
		      ActionForm form, HttpServletRequest request,
		      HttpServletResponse response)
		      throws Exception {
			FacturaMestreDetallPojo facturaContainerPojo = formExtractor.extractPojo(form);
			attachFactura(facturaContainerPojo);
			attachLinia(facturaContainerPojo);
			liniesValueListActionHelper.search(mapping, form, request, response);
			facturaContainerPojo.setCurrentLiniaVisible(true);
			facturaContainerPojo.setCurrentLiniaIsNewInstance(false);
			setDefaultSuccessMessage("edita.linia");
			calculaTotalFactura(request, facturaContainerPojo);
		    return mapping.findForward("view");
	}
	
	public ActionForward deleteLinia(ActionMapping mapping,
		      ActionForm form, HttpServletRequest request,
		      HttpServletResponse response)
		      throws Exception {
		
		FacturaMestreDetallPojo facturaContainerPojo = formExtractor.extractPojo(form);
		
		
		//2.execucio d'accions de negoci (discriminem l'accio de negoci segons l'estat de patanlla)
		if(facturaContainerPojo.isCurrentLiniaIsNewInstance()){
			throw new WrappedCheckedException();
		}
		else{
			attachLinia(facturaContainerPojo);
			facturaBO.deleteLinia(facturaContainerPojo.getCurrentLinia());
		}
		
		//3.preparacio de context per la vista

		attachFactura(facturaContainerPojo);
		
		
		preparaLiniaValuelist(mapping, form, request, response, facturaContainerPojo);
		facturaContainerPojo.setCurrentLiniaVisible(false);
		facturaContainerPojo.setCurrentLiniaIsNewInstance(false);
		setDefaultSuccessMessage("esborrada.linia");
		// Mode del formulari a INSPECT (consulta)
		FormUtils.setFormDisplayMode(request, form,FormUtils.INSPECT_MODE);
		calculaTotalFactura(request, facturaContainerPojo);
	    return mapping.findForward("view");
	}
	
	public ActionForward saveLinia(ActionMapping mapping,
		      ActionForm form, HttpServletRequest request,
		      HttpServletResponse response)
		      throws Exception {
		
			//1.Obtencio del pojo (container vinculat o binding) 
			FacturaMestreDetallPojo facturaContainerPojo = formExtractor.extractPojo(form);
			
			
			//2.execucio d'accions de negoci (discriminem l'accio de negoci segons l'estat de patanlla)
			if(facturaContainerPojo.isCurrentLiniaIsNewInstance()){
				facturaBO.addLinia(facturaContainerPojo.getFactura(),facturaContainerPojo.getCurrentLinia());
			}
			else{
				facturaBO.updateLinia(facturaContainerPojo.getCurrentLinia());
			}
			
			//3.preparacio de context per la vista

			attachLinia(facturaContainerPojo);
			
			
			preparaLiniaValuelist(mapping, form, request, response,
					facturaContainerPojo);
			
			facturaContainerPojo.setCurrentLiniaVisible(false);
			facturaContainerPojo.setCurrentLiniaIsNewInstance(false);
			facturaContainerPojo.setLiniaListVisible(true);
			setDefaultSuccessMessage("desada.linia");

			// Mode del formulari a INSPECT (consulta)
			FormUtils.setFormDisplayMode(request, form,FormUtils.INSPECT_MODE);
			calculaTotalFactura(request, facturaContainerPojo);
		    return mapping.findForward("view");
	}

	/**
	 * Metode de conveniencia per recarregar  des de hibernate, i a partir del id contingut al pojo, una factura
	 *  deixant-lo al pojo com  a instancia persistent fent servir el metode getFactura del BO.
	 *  
	 * @param facturaContainerPojo
	 */
	private void attachFactura(FacturaMestreDetallPojo facturaContainerPojo) {
		Long facturaKey = facturaContainerPojo.getFactura().getId();
		facturaContainerPojo.setFactura(facturaBO.getFactura(facturaKey));
	}
	
	/**
	 * Metode de conveniencia per recarregar  des de hibernate, i a partir del id contingut al pojo, una linia
	 *  deixant-lo al pojo com  a instancia persistent fent servir el metode getLinia del BO.
	 *  
	 * @param facturaContainerPojo
	 */
	private void attachLinia(FacturaMestreDetallPojo facturaContainerPojo) {
		Long liniaKey = facturaContainerPojo.getCurrentLinia().getId();
		facturaContainerPojo.setCurrentLinia(facturaBO.getLinia(liniaKey));
	}

	/**
	 * @param request
	 * @param facturaContainerPojo
	 */
	private void calculaTotalFactura(HttpServletRequest request,
			FacturaMestreDetallPojo facturaContainerPojo) {
		float total = 0;
		Factura factura = facturaContainerPojo.getFactura();
		if(factura != null) {			
			List<Linia> linies = facturaBO.getFactura(factura.getId()).getLinies();
			if(linies != null && linies.size() > 0) {
				for (Iterator<Linia> iterator = linies.iterator(); iterator.hasNext();) {
					Linia linia = (Linia) iterator.next();
					total = total + (linia.getPreu()*linia.getQuantitat());
				}
			}
		}
		request.setAttribute("totalFactura", total);
	}
}
