package net.gencat.ctti.canigo.exempleMestreDetall.model;

import java.io.Serializable;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;

/**
 * =======================================================================
 * OT Canig
 * 
 * Aquesta classe s una entitat persistent.
 * T com a atributs un identificador (PK) i altres caracterstiques, i 
 * est associat a l'entitat Factura amb relaci N:1
 * ========================================================================
 *
 */

@Entity
@NamedQueries( {
    @NamedQuery( name = "Linia.findLiniesByFactura", 
		     query = "SELECT linia FROM Linia linia WHERE linia.factura.numFactura=?1" ),
       @NamedQuery( name = "Linia.findInLiniaIds", 
		     query = "SELECT o FROM Linia o  WHERE  o.id in  ( ?1 )" )
} )
public class Linia implements Serializable {
	private static final long serialVersionUID = 1L;

	@Id
    @GeneratedValue( strategy = GenerationType.AUTO )
    private Long id;
	
    private String numArticle;
	private String article;
	private int quantitat;
	private float preu;
	
	@ManyToOne(cascade=CascadeType.ALL)
    private Factura factura;
    
    public Linia() {
    	
    }

    /**
	 * @return the id
	 */
	public Long getId() {
        return id;
    }

	/**
	 * @param id the id to set
	 */
	public void setId( Long id ) {
        this.id = id;
    }

	/**
	 * @return the numArticle
	 */
	public String getNumArticle() {
		return numArticle;
	}

	/**
	 * @param numArticle the numArticle to set
	 */
	public void setNumArticle(String numArticle) {
		this.numArticle = numArticle;
	}
	
	/**
	 * @return the article
	 */
	public String getArticle() {
		return article;
	}

	/**
	 * @param article the article to set
	 */
	public void setArticle(String article) {
		this.article = article;
	}

	/**
	 * @return the quantitat
	 */
	public int getQuantitat() {
		return quantitat;
	}

	/**
	 * @param quantitat the quantitat to set
	 */
	public void setQuantitat(int quantitat) {
		this.quantitat = quantitat;
	}

	/**
	 * @return the preu
	 */
	public float getPreu() {
		return preu;
	}

	/**
	 * @param preu the preu to set
	 */
	public void setPreu(float preu) {
		this.preu = preu;
	}

	/**
	 * @return the factura
	 */
	public Factura getFactura() {
		return factura;
	}

	/**
	 * @param factura the factura to set
	 */
	public void setFactura(Factura factura) {
		this.factura = factura;
	}
    
	@Override
	public boolean equals(Object arg0) {
		if (arg0 == null) {
			return false;
		}
		if (arg0 instanceof Linia) {
			Linia otherLinia = (Linia) arg0;
			return otherLinia.getNumArticle().equals(this.getNumArticle());
		}
		return super.equals(arg0);
	}

	@Override
	public int hashCode() {
		if(this.id==null){
			return super.hashCode();
		}
		return this.id.hashCode();
	}
}
