package net.gencat.ctti.canigo.galeria.action;


import java.util.Arrays;
import java.util.HashSet;
import java.util.Set;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.gencat.ctti.canigo.galeria.bo.AnimalsBO;
import net.gencat.ctti.canigo.galeria.bo.CategoriesBO;
import net.gencat.ctti.canigo.galeria.model.AnimalPojo;
import net.gencat.ctti.canigo.galeria.model.GaleriaPojo;
import net.gencat.ctti.canigo.services.logging.Log;
import net.gencat.ctti.canigo.services.logging.LoggingService;
import net.gencat.ctti.canigo.services.web.struts.DispatchActionSupport;
import net.gencat.ctti.canigo.services.web.struts.SpringBindingActionForm;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * ======================================================================
 * OT Canig
 * 
 * Aquesta classe cont les accions associades al formulari 
 * (l'associaci de formulari-acci es fa en el fitxer action-servlet.xml)
 * =======================================================================
 *
 */

public class GaleriaAction extends DispatchActionSupport{

	private AnimalsBO animalsBO;
	private CategoriesBO categoriesBO;
	

	public AnimalsBO getAnimalsBO() {
		return animalsBO;
	}

	public void setAnimalsBO(AnimalsBO animalsBO) {
		this.animalsBO = animalsBO;
	}
	
	public CategoriesBO getCategoriesBO() {
		return categoriesBO;
	}

	public void setCategoriesBO(CategoriesBO categoriesBO) {
		this.categoriesBO = categoriesBO;
	}

	private Log logger;
	
	public void setLogService(LoggingService logService) {
		super.setLogService(logService);
		logger=logService.getLog(GaleriaAction.class);
	}

	public ActionForward create(ActionMapping mapping,
	      ActionForm form, HttpServletRequest request,
	      HttpServletResponse response)
	      throws Exception {
		GaleriaPojo galeriaPojo = extractPojo(form);
		//inicialitzacio de les llistes de seleccio
		galeriaPojo.getAllAnimalsList().addAll(animalsBO.getAllAnimals());
		galeriaPojo.getAllCategoriesList().addAll(categoriesBO.getAllCategories());
	    return mapping.findForward("edit");
	   }
	
	   public ActionForward edit(ActionMapping mapping,
	      ActionForm form, HttpServletRequest request,
	      HttpServletResponse response)
	      throws Exception {
	      return mapping.findForward("edit");
	   }
	   public ActionForward save(ActionMapping mapping,
	      ActionForm form, HttpServletRequest request,
	      HttpServletResponse response)
	      throws Exception {
   			GaleriaPojo galeriaPojo = extractPojo(form); 
	 		   logger.info("GaleriaAction save:");
	 		   logger.info("\tpojo.nom=" + galeriaPojo.getNom());
	 		   logger.info("\tpojo.password=" + galeriaPojo.getPassword());
	 		   logger.info("\tpojo.habil=" + galeriaPojo.isHabil());
	 		   logger.info("\tpojo.optionValue=" + galeriaPojo.getOptionValue());
	 		   logger.info("\tpojo.dataCreacio=" + galeriaPojo.getDataCreacio());
	 		   logger.info("\tpojo.selectPojo.id=" + galeriaPojo.getSelectPojo().getId());
	 		   
	 		   Set<String> hatedSet = new HashSet<String>(Arrays.asList(galeriaPojo.getHateAnimals()));
	 		   for (AnimalPojo animalPojo : animalsBO.getAllAnimals()) {
	 			   if(hatedSet.contains(animalPojo.getId().toString())){
	 				   galeriaPojo.getHateAnimalsList().add(animalPojo);
					}
					else{
						galeriaPojo.getAllAnimalsList().add(animalPojo);
					}
		 		 }
	 		   return mapping.findForward("edit");
	   }

	private GaleriaPojo extractPojo(ActionForm form) {
		SpringBindingActionForm actionForm = (SpringBindingActionForm) form;
		
		GaleriaPojo galeriaPojo = (GaleriaPojo) actionForm.getTarget();
		return galeriaPojo;
	}
	
}
