package net.gencat.ctti.canigo.galeria.model;

import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.OneToMany;

/**
 * =======================================================================
 * OT Canig
 * 
 * Aquesta classe s una entitat persistent.
 * T com a atributs un identificador i un nom, i est associat a l'entitat
 * AnimalPojo amb relaci 1:N
 * ========================================================================
 *
 */

@Entity
public class CategoriaPojo {
	
	@Id
	private Long id;
	
	private String nom;
	
	@OneToMany(mappedBy = "categoria", cascade = CascadeType.ALL)
	private List<AnimalPojo> animals = null;

	public List<AnimalPojo> getAnimals() {
		return animals;
	}
	
	public void setAnimals(List<AnimalPojo> animals) {
		this.animals = animals;
	}

	public CategoriaPojo() {
		super();
	}
	
	public CategoriaPojo(Long id, String nom) {
		super();
		this.id = id;
		this.nom = nom;
	}
	
	public Long getId() {
		return id;
	}
	
	public void setId(Long id) {
		this.id = id;
	}
	
	public String getNom() {
		return nom;
	}
	
	public void setNom(String nom) {
		this.nom = nom;
	}
	
	@Override
	public String toString() {
		return nom;
	}

	
}
