/**
 * 
 */
package net.gencat.ctti.canigo.galeria.tags.support;

import java.util.ArrayList;
import java.util.Hashtable;
import java.util.Map;
import java.util.Set;

import javax.servlet.http.HttpServletRequest;

import net.gencat.ctti.canigo.services.i18n.I18nService;
import net.gencat.ctti.canigo.services.web.taglib.Constants;
/**
 * Permet configurar per Spring un map<String,String> com a origen de dades d'un select, configurat a canigo-web-options-lists:
 * 
 * 
 *         <entry key="exempleSelectList">
			<bean	class="net.gencat.ctti.canigo.galeria.tags.support.MapBasedOptionListSource">
			<property name="i18nService" ref="i18nService"></property>
			<property name="valuesMap">
			<map>
				<entry key="1" value="selectPojo1"></entry>
				<entry key="2" value="selectPojo2"></entry>
				<entry key="3" value="selectPojo3"></entry>
			</map>
			</property>
			</bean> 
        </entry>
        
        
 * 
 * els valors passsen pel servei i18n (es traduiran).
 * 
 * Per configurar el tag es referencia optionsListName com en el cas de llistes tretes de Hibernate
 *  
 * 					<bean parent="selectFieldTag">
						<property name="styleId" value="selectPojo"></property>
						<property name="optionsListName" value="exempleSelectList"></property>
						<property name="layout" value="true"/>
					</bean>
 * 
 * @author romaferre
 *
 */
public class MapBasedOptionListSource
		extends
		net.gencat.ctti.canigo.services.web.taglib.util.options.OptionsListSourceBase {

	private I18nService i18nService;
	public I18nService getI18nService() {
		return i18nService;
	}

	public void setI18nService(I18nService service) {
		i18nService = service;
	}

	private Map valuesMap;
	
	public Map getValuesMap() {
		return valuesMap;
	}

	public void setValuesMap(Map valuesMap) {
		this.valuesMap = valuesMap;
	}

	protected void loadOptions(HttpServletRequest request) {
		prepareOptions();
	}

	protected void loadOptions(Map requestMap) {
		prepareOptions();
	}

	private void prepareOptions() {
		ArrayList list = new ArrayList();
		Set<Map.Entry<Object, Object>> entrySet = valuesMap.entrySet();
		for (Map.Entry<Object, Object> entry : entrySet) {
			Map map = new Hashtable();
			map.put(Constants.VALUE, entry.getKey().toString());
			map.put(Constants.LABEL, i18nService.getMessage(entry.getValue().toString()));
			list.add(map);
		}


		setOptions(list);
	}

}