package net.gencat.ctti.canigo.samples.prototip.security;

import org.springframework.context.ApplicationContext;

import net.gencat.ctti.canigo.services.security.AbstractAuthenticationConfiguration;
import net.sf.acegisecurity.GrantedAuthority;
import net.sf.acegisecurity.providers.AuthenticationProvider;

public class MemAuthenticationConfiguration extends AbstractAuthenticationConfiguration {
	
	private String username = "";
	private String password = "";
	private GrantedAuthority[] authorities;
	
	protected AuthenticationProvider getAuthenticationProvider(
			ApplicationContext applicationContext) throws Exception {

		MemoryAuthenticationProvider authenticationProvider = new MemoryAuthenticationProvider();
		authenticationProvider.setUsername(username);
		authenticationProvider.setPassword(password);
		authenticationProvider.setAuthorities(authorities);
		return authenticationProvider;
	}

	public void afterPropertiesSet() throws Exception {
		// TODO Auto-generated method stub
		
	}

	/**
	 * @return the username
	 */
	public String getUsername() {
		return username;
	}

	/**
	 * @param username the username to set
	 */
	public void setUsername(String username) {
		this.username = username;
	}

	/**
	 * @return the password
	 */
	public String getPassword() {
		return password;
	}

	/**
	 * @param password the password to set
	 */
	public void setPassword(String password) {
		this.password = password;
	}

	/**
	 * @return the authorities
	 */
	public GrantedAuthority[] getAuthorities() {
		return authorities;
	}

	/**
	 * @param authorities the authorities to set
	 */
	public void setAuthorities(GrantedAuthority[] authorities) {
		this.authorities = authorities;
	}

}
