package net.gencat.ctti.canigo.samples.prototip.security;

import net.sf.acegisecurity.AuthenticationException;
import net.sf.acegisecurity.BadCredentialsException;
import net.sf.acegisecurity.GrantedAuthority;
import net.sf.acegisecurity.UserDetails;
import net.sf.acegisecurity.providers.UsernamePasswordAuthenticationToken;
import net.sf.acegisecurity.providers.dao.User;

import org.acegisecurity.providers.dao.AbstractUserDetailsAuthenticationProvider;
import org.springframework.util.Assert;

public class MemoryAuthenticationProvider extends AbstractUserDetailsAuthenticationProvider {
	
	private String username = "";
	private String password = "";
	private GrantedAuthority[] authorities;
	

	protected void additionalAuthenticationChecks(UserDetails userDetails,
			UsernamePasswordAuthenticationToken authentication)
			throws AuthenticationException {
	}

	protected UserDetails retrieveUser(String username,
            UsernamePasswordAuthenticationToken authentication)
            throws AuthenticationException {
        Assert.hasText(username);
        Assert.notNull(authentication.getCredentials());
        if (username.equals(this.username)
                && authentication.getCredentials().equals(password)) {
            return new User(this.username, password, true, true, true, true,
                    getAuthorities());
        }
        throw new BadCredentialsException("invalid username/password");
    }
    /*
     * return GrantedAuthorities
     */
    private GrantedAuthority[] getAuthorities() {
    	return authorities;
    }

	/**
	 * @return the username
	 */
	public String getUsername() {
		return username;
	}

	/**
	 * @param username the username to set
	 */
	public void setUsername(String username) {
		this.username = username;
	}

	/**
	 * @return the password
	 */
	public String getPassword() {
		return password;
	}

	/**
	 * @param password the password to set
	 */
	public void setPassword(String password) {
		this.password = password;
	}

	/**
	 * @param authorities the authorities to set
	 */
	public void setAuthorities(GrantedAuthority[] authorities) {
		this.authorities = authorities;
	}

}
